<script src="https://unpkg.com/d3@3/d3.min.js"></script>
<script src="https://unpkg.com/function-plot@1/dist/function-plot.js"></script>

<script>


    // difficulty calculation settings
    $('#start-diff-comp-btn').on('click', function (evt) {
        var modalDialog = $('#irtComputationDialog');
        var modalProgress = $('#irtComputationProgress');
        var modalResults = $('#irtComputationResults');

        var minAnswers = $('#irt_min_answers_threshold').val();
        var modelParamsNo = $('#no_model_params_1').is(':checked') ? 1 : 2;

        modalDialog.modal('hide');
        modalProgress.modal('show');

        $.post('questions/compute-difficulties', {
            min_answers: minAnswers,
            no_model_params: modelParamsNo
        }).always(data => {
            $('#irtComputationResultsContainer').html(JSON.stringify(data));
            modalProgress.modal('hide');
            modalResults.modal('show');
        })
    });

    // ICC plotting
    function getFunctionExpression(b, a) {
        return a ? `1 / (1 + 2.71828182846^(${-a} * (x - ${b})))` :
            // 2-param Lord model or 1-param Rasch model
            `1 / (1 + 2.71828182846^-(x - ${b}))`;
    }

    function bigPlot(b1, b2, a2) {
        var data = [];

        if (b1)
            data.push({
                fn: getFunctionExpression(b1),
                graphType: 'polyline',
                color: 'purple'
            });
        if (b2 && a2)
            data.push({
                fn: getFunctionExpression(b2, a2),
                graphType: 'polyline',
                color: 'teal'
            });

        functionPlot({
            target: '#plot',
            width: 1024,
            height: 768,
            xAxis: {
                label: 'student ability'
            },
            yAxis: {
                label: 'correct answer probability',
                domain: [0, 1]
            },
            data: data
        });

        $('#IccPlot').show();
    }

    function closePlot() {
        $('#IccPlot').hide();
    }

    // small ICC plotting
    $('#questionsTable .questionIcc').each(function () {
        $this = $(this);
        var b1 = $this.attr('data-1-b'),
            b2 = $this.attr('data-2-b')
        a2 = $this.attr('data-2-a'),
            idx = $this.attr('data-idx'),
            data = [];

        if (!b1 && !b2) return;
        if (b1)
            data.push({
                fn: getFunctionExpression(b1),
                graphType: 'polyline',
                color: 'purple'
            });
        if (b2 && a2)
            data.push({
                fn: getFunctionExpression(b2, a2),
                graphType: 'polyline',
                color: 'teal'
            });

        try {

            functionPlot({
                target: `#questionIcc-${idx}`,
                width: 200,
                height: 200,
                yAxis: {
                    domain: [0, 1]
                },
                data: data
            });
        } catch (e) {
            $(`#questionIcc-${idx}`).html(`<b>Error</b>: ${e}`);
        }
    });

    // assign difficulties based on computed difficulties
    function assignDifficulties(maxIccErr, minSampleSize, override = false) {
        var minCorrPercModel, maxCorrPercModel,
            min1ParamModel, max1ParamModel, min2ParamModel, max2ParamModel,
            tableRows = $('#questionsTable tbody tr');

        // calculate difficulty parameter intervals
        tableRows.each(function () {
            $this = $(this);
            var noAnswers = parseInt($this.find(".no_answers").html()),
                correctPercentage = parseFloat($this.find(".correct_percentage").html()),
                difficulty_1 = parseFloat($this.find('.questionIcc').attr('data-1-b')),
                difficulty_std_err_1 = parseFloat($this.find('.diff-std-err-1').html()),
                difficulty_2 = parseFloat($this.find('.questionIcc').attr('data-2-b')),
                difficulty_std_err_2 = parseFloat($this.find('.diff-std-err-2').html());

            if (noAnswers >= minSampleSize) {
                if (correctPercentage < minCorrPercModel || !minCorrPercModel)
                    minCorrPercModel = correctPercentage;
                if (correctPercentage > maxCorrPercModel || !maxCorrPercModel)
                    maxCorrPercModel = correctPercentage;
            }


            if (!difficulty_std_err_1 || difficulty_std_err_1 <= maxIccErr) {
                if (difficulty_1 < min1ParamModel || !min1ParamModel)
                    min1ParamModel = difficulty_1;
                if (difficulty_1 > max1ParamModel || !max1ParamModel)
                    max1ParamModel = difficulty_1;
            }

            if (!difficulty_std_err_2 || difficulty_std_err_2 <= maxIccErr) {
                if (difficulty_2 < min2ParamModel || !min2ParamModel)
                    min2ParamModel = difficulty_2;
                if (difficulty_2 > max2ParamModel || !max2ParamModel)
                    max2ParamModel = difficulty_2;
            }

            //console.log(noAnswers, correctPercentage, difficulty_1, difficulty_std_err_1, difficulty_2, difficulty_std_err_2);

        });

        var intCorrPercModel = maxCorrPercModel - minCorrPercModel,
            int1ParamModel = max1ParamModel - min1ParamModel,
            int2ParamModel = max2ParamModel - min2ParamModel

        var intervals = ['Interval of correct percentage',
            `[${minCorrPercModel}, ${maxCorrPercModel}] - length ${intCorrPercModel}`,
            'Interval of difficulty param in 1-param model',
            `[${min1ParamModel}, ${max1ParamModel}] - length ${int1ParamModel}`,
            'Interval of difficulty param in 2-param model',
            `[${min2ParamModel}, ${max2ParamModel}] - length ${int2ParamModel}`
        ];

        var assignments = 0,
            changes = 0,
            fullMatches = 0,
            majorityMatches = 0,
            mismatches = 0,
            totalCalculations = 0,
            totalQuestions = 0;

        function getDifficultyOrdinal(value, start, step, diffLevelsNumber) {
            var bound = start + step;
            var i;
            for (i = 1; i <= diffLevelsNumber; ++i) {
                if (value <= bound) {
                    return i;
                }
                bound += step;
            }
            return i - 1;
        }

        tableRows.each(function () {
            $this = $(this);
            var noAnswers = parseInt($this.find(".no_answers").html()),
                correctPercentage = parseFloat($this.find(".correct_percentage").html()),
                difficulty_1 = parseFloat($this.find('.questionIcc').attr('data-1-b')),
                difficulty_std_err_1 = parseFloat($this.find('.diff-std-err-1').html()),
                difficulty_2 = parseFloat($this.find('.questionIcc').attr('data-2-b')),
                difficulty_std_err_2 = parseFloat($this.find('.diff-std-err-2').html()),
                diffLevelsNumber = $this.find('.form-check-input').length - 1,
                diffCorrPercModel, diff1ParamModel, diff2ParamModel;

            if (correctPercentage && noAnswers && noAnswers >= minSampleSize) {
                diffCorrPercModel = diffLevelsNumber -
                    getDifficultyOrdinal(correctPercentage, minCorrPercModel, intCorrPercModel /
                        diffLevelsNumber, diffLevelsNumber) + 1;
            }

            if (difficulty_1 && (difficulty_std_err_1 < maxIccErr || !difficulty_std_err_1)) {
                diff1ParamModel = getDifficultyOrdinal(difficulty_1, min1ParamModel, int1ParamModel /
                    diffLevelsNumber, diffLevelsNumber);
            }

            if (difficulty_2 && (difficulty_std_err_2 < maxIccErr || !difficulty_std_err_2)) {
                diff2ParamModel = getDifficultyOrdinal(difficulty_2, min2ParamModel, int2ParamModel /
                    diffLevelsNumber, diffLevelsNumber);
            }

            /*
            console.log(
                `question ${$this.find('.idVerAct').html().match(/[\d]{3,6}/)} difficulties per each model`,
                diffCorrPercModel, diff1ParamModel, diff2ParamModel);
            console.log(difficulty_1, difficulty_2);
            */

            if (diffCorrPercModel || difficulty_1 || difficulty_2) {
                var resultingDiff, resultingCase, 
                    resultingCases = ['Full match', 'Majority match', 'Mismatch'];

                if (diffCorrPercModel == diff1ParamModel == diff2ParamModel ||
                    diffCorrPercModel == diff1ParamModel && !diff2ParamModel ||
                    diffCorrPercModel == diff2ParamModel && !diff1ParamModel ||
                    diff1ParamModel == diff2ParamModel && !diffCorrPercModel) {

                    resultingDiff = diffCorrPercModel ? diffCorrPercModel :
                        diff1ParamModel ? diff1ParamModel : diff2ParamModel;
                    resultingCase = 0;
                    ++fullMatches;
                } else if (diffCorrPercModel == diff1ParamModel && diff2ParamModel || 
                    diffCorrPercModel == diff2ParamModel && diff1ParamModel ||
                    diff1ParamModel == diff2ParamModel && diffCorrPercModel) {

                    resultingDiff = diffCorrPercModel ? diffCorrPercModel :
                        diff1ParamModel ? diff1ParamModel : diff2ParamModel;
                    resultingCase = 1;
                    ++majorityMatches;
                } else {
                    resultingCase = 2;
                    ++mismatches;
                }   

                var unknown = model1 = difficultyLevels.find(x => x.name == 'None')
                var model1 = difficultyLevels.find(x => x.ordinal == diffCorrPercModel) || unknown,
                    model2 = difficultyLevels.find(x => x.ordinal == diff1ParamModel) || unknown,
                    model3 = difficultyLevels.find(x => x.ordinal == diff2ParamModel) || unknown;

                var results =
                    `<a class="dropdown-item" style="border-color: #${model1.rgb_color};">correct percentage model: ${
                        diffCorrPercModel ? model1.name : 'skipped'}</a>
                    <a class="dropdown-item" style="border-color: #${model2.rgb_color};">1-param IRT model: ${
                        diff1ParamModel ? model2.name : 'skipped'}</a>
                    <a class="dropdown-item" style="border-color: #${model3.rgb_color};">2-param IRT model: ${
                        diff2ParamModel ? model3.name : 'skipped'}</a>`;
                var dropdown = $this.find('.assign-diffs-stat');
                dropdown.html(
                    `<div class="dropdown">
                        <button class="btn btn-sm dropdown-toggle btn-${resultingCase == 0 ? 'success' : 
                        resultingCase == 1 ? 'info' : 'danger'
                    }" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            ${resultingCases[resultingCase]}
                        </button>
                        <div class="dropdown-menu">
                            ${results}
                        </div>
                    </div>`
                );

                ++totalCalculations;
            }

            ++totalQuestions;

            var checkboxes = $this.find('.form-check-input'),
                hasDifficulty = false;
            checkboxes.each((idx, cb) => {
                if (idx !== 0 && cb.checked) {
                    hasDifficulty = true;
                }
            });

            checkboxes.each((idx, val) => {
                if (resultingDiff == idx) {
                    if (override || !hasDifficulty) {
                        if (val.checked == false && hasDifficulty)
                            ++changes;

                        val.checked = true;

                        if (!hasDifficulty)
                            ++assignments;
                    }
                }
            })
        });

        var results =
            `<h5>Model difficulty level match percentage</h5>
            <p>${fullMatches} (${Math.round(fullMatches / totalCalculations * 100)}%) full matches<br />
            All available models for the question gave the same difficulty level</p>
            <p>${majorityMatches} (${Math.round(majorityMatches / totalCalculations * 100)}%) majority matches<br />
            Two of three models available gave the same match or only one model was available and used</p>
            <p>${mismatches} (${Math.round(mismatches / totalCalculations * 100)}%) mismatches<br />
            No majority or full match for the available models, difficulty not assigned<br />
            ${mismatches > 0 && '<b>Please assign difficulties for those questions manually!</b>'}
            </p>
            <h5>Calculations</h5>
            <p>
            ${totalCalculations} total calculations.<br />
            ${Math.round((totalCalculations) / totalQuestions * 100)}% questions processed.<br />
            ${totalQuestions - totalCalculations} questions skipped due to ignore settings.<br />
            ${assignments} assignments and ${changes} changes of difficulty levels.
            </p>`;

        $('#assign-diffs-results').html(
            `<h5>Difficulty parameter intervals</h5><p>${
            intervals.join('<br />')
        }${results}`
        );
        $('#assignDifficultiesResults').modal('show');
    }

    var diffsModalDialog = $('#assignDifficultiesDialog');

    $('#assign-diffs-btn').on('click', function () {
        $this = this;
        diffsModalDialog.modal('show');
    });

    $('#confirm-assign-diffs-btn').on('click', function () {
        $this = this;
        diffsModalDialog.modal('hide');

        var iccMaxStdErr = $('#icc_max_std_err').val(),
            corrPercMinAnswers = $('#corr_perc_min_answers').val(),
            noDiffOverride = $('#no_diff_override').is(':checked');

        assignDifficulties(iccMaxStdErr, corrPercMinAnswers, !noDiffOverride);
    });

    $('#del-diffs-btn').on('click', function() {
        $(':input[type="radio"][value=""]')
        .prop('checked', true);
    })
</script>